// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Mller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <aoc/Solver.hpp>

class PrintQueue
    : public Solver
{
public:
    PrintQueue();
    const std::string getPuzzleName() const override;
    const std::string getInputFileName() const override;
    void processDataLine(const std::string& line) override;
    void finish() override;
private:
    static const int nPages_{ 49 };
    static const int maxPageNo_{ 99 };
    bool isProcessingOrderingRules_;
    int pageNoMapIndex_;
    int pageNoMap_[maxPageNo_ + 1];
    bool orderingRules_[nPages_][nPages_];
    size_t getMapped(const int pageNo);
    void processOrderingRule(const std::string& line);
    void processUpdatePages(const std::string& line);
};
